package com.springboot.app.JibberJabberRestAPI;


import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;

import javax.persistence.*;
import java.util.Date;
import java.util.Objects;


@Entity
@Getter
@Setter
@Table(name = "jibbers")
public class Jibber {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private int id;

    private String message;

    @CreationTimestamp
    @Column(name = "created_date")
    private Date createdDate;

    Jibber () {}

    Jibber(String message, Date createdDate) {
        this.message = message;
        this.createdDate = createdDate;
    }

    @Override
    public boolean equals(Object o) {

        if (this == o)
            return true;
        if (!(o instanceof Jibber))
            return false;
        Jibber jibber = (Jibber) o;
        return Objects.equals(this.id, jibber.id) && Objects.equals(this.message, jibber.message)
                && Objects.equals(this.createdDate, jibber.createdDate);
    }

    @Override
    public int hashCode() {
        return Objects.hash(this.id, this.message, this.createdDate);
    }

    @Override
    public String toString() {
        return "Jibber{" + "id=" + this.id + ", message='" + this.message + '\'' + ", createdDate='" + this.createdDate
                + '\'' + '}';
    }
}
