package com.springboot.app.JibberJabberRestAPI;


import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
public class UserController {

    private final UserRepository repository;


    UserController(UserRepository repository) {
        this.repository = repository;
    }

    @GetMapping("/users")
    List<User> all() {
        return repository.findAll();
    }

    @PostMapping("/users")
    User newUser(@RequestBody User newUser) {
        return repository.save(newUser);
    }

    //single item


    @GetMapping("/users/{handle}")
    User one(@PathVariable String handle) {

        return repository.findByhandle(handle)
                .orElseThrow(() -> new UserNotFoundException((handle)));
    }
}
